- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# usprep.h File Reference

C API: Implements the StringPrep algorithm. More...

`#include "unicode/utypes.h"`
`#include "unicode/parseerr.h"`

Go to the source code of this file.

## Defines
#define | USPREP_DEFAULT 0x0000
| Option to prohibit processing of unassigned code points in the input.
#define | USPREP_ALLOW_UNASSIGNED 0x0001
| Option to allow processing of unassigned code points in the input.
## Typedefs
typedef UStringPrepProfile | UStringPrepProfile
| The StringPrep profile.
## Functions
UStringPrepProfile * | usprep_open (const char *path, const char *fileName, UErrorCode *status)
| Creates a StringPrep profile from the data file.
void | usprep_close (UStringPrepProfile *profile)
| Closes the profile.
int32_t | usprep_prepare (const UStringPrepProfile *prep, const UChar *src, int32_t srcLength, UChar *dest, int32_t destCapacity, int32_t options, UParseError *parseError, UErrorCode *status)
| Prepare the input buffer for use in applications with the given profile.

## Detailed Description

C API: Implements the StringPrep algorithm.

Definition in file usprep.h.

## Define Documentation

#define USPREP_ALLOW_UNASSIGNED 0x0001

Option to allow processing of unassigned code points in the input.

See also:
  usprep_prepare

Stable:
  ICU 2.8

Definition at line 83 of file usprep.h.

#define USPREP_DEFAULT 0x0000

Option to prohibit processing of unassigned code points in the input.

See also:
  usprep_prepare

Stable:
  ICU 2.8

Definition at line 75 of file usprep.h.

## Typedef Documentation

typedef struct UStringPrepProfile UStringPrepProfile

The StringPrep profile.

Stable:
  ICU 2.8

Definition at line 66 of file usprep.h.

## Function Documentation

void usprep_close | ( | UStringPrepProfile * | profile | ) |

Closes the profile.

Parameters:

  | profile | The profile to close

Stable:
  ICU 2.8

UStringPrepProfile* usprep_open | ( | const char * | path,
|  | const char * | fileName,
|  | UErrorCode * | status |
| ) |  |  |

Creates a StringPrep profile from the data file.

Parameters:

  | path | string containing the full path pointing to the directory where the profile reside followed by the package name e.g. "/usr/resource/my_app/profiles/mydata" on a Unix system. if NULL, ICU default data files will be used.
  | fileName | name of the profile file to be opened
  | status | ICU error code in/out parameter. Must not be NULL. Must fulfill U_SUCCESS before the function call.

Returns:
  Pointer to UStringPrepProfile that is opened. Should be closed by calling usprep_close()

See also:
  usprep_close()

Stable:
  ICU 2.8

int32_t usprep_prepare | ( | const UStringPrepProfile * | prep,
|  | const UChar * | src,
|  | int32_t | srcLength,
|  | UChar * | dest,
|  | int32_t | destCapacity,
|  | int32_t | options,
|  | UParseError * | parseError,
|  | UErrorCode * | status |
| ) |  |  |

Prepare the input buffer for use in applications with the given profile.

This operation maps, normalizes(NFKC), checks for prohited and BiDi characters in the order defined by RFC 3454 depending on the options specified in the profile.

Parameters:

  | prep | The profile to use
  | src | Pointer to UChar buffer containing the string to prepare
  | srcLength | Number of characters in the source string
  | dest | Pointer to the destination buffer to receive the output
  | destCapacity | The capacity of destination array
  | options | A bit set of options:

- USPREP_NONE Prohibit processing of unassigned code points in the input

- USPREP_ALLOW_UNASSIGNED Treat the unassigned code points are in the input as normal Unicode code points.

Parameters:

  | parseError | Pointer to UParseError struct to receive information on position of error if an error is encountered. Can be NULL.
  | status | ICU in/out error code parameter. U_INVALID_CHAR_FOUND if src contains unmatched single surrogates. U_INDEX_OUTOFBOUNDS_ERROR if src contains too many code points. U_BUFFER_OVERFLOW_ERROR if destCapacity is not enough

Returns:
  The number of UChars in the destination buffer

Stable:
  ICU 2.8